=== docs/CMakeLists.txt ===
if(XTRKCAD_USE_DOXYGEN)
  add_subdirectory(doxygen)
endif(XTRKCAD_USE_DOXYGEN)
