=== debian/changelog ===
xtrkcad (1:5.3.0GA-1.1build1) plucky; urgency=medium

  * Rebuild against latest libzip

 -- Jeremy Bícha <jbicha@ubuntu.com>  Fri, 22 Nov 2024 08:56:25 -0500

xtrkcad (1:5.3.0GA-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Reintroduce changes from 1:5.2.0Beta2.1-2 accidentally dropped by the
    last upload. (Closes: #1087529, #1066691)
  * Delete precompiled libzip.a via d/clean (Closes: #1087474)

 -- Tobias Frost <tobi@debian.org>  Thu, 14 Nov 2024 20:36:25 +0100

xtrkcad (1:5.3.0GA-1) unstable; urgency=medium

  * New upstream release (Closes: #1057286, #1074722):
  * debian/control:
    - Add Build-Depends:
      + inkscape
      + libfreeimage-dev
      + pandoc
    - Change to new repository URL.
    - Change Standards-Version to 4.7.0.0 (No changes needed).
    - Add myself as Maintainer and Daniel E. Markle as Uploader.
      (Closes: #1057287)
  * debian/xtrkcad.install:
    - Add CHANGELOG.txt, Readme.txt
  * debian/copyright:
    - Add year 2024 to myself.
    - Rebase for the new release.
  * debian/changlog:
    - Remove trailing whitespace.
  * debian/rules:
    - Remove trailing whitespace.

 -- Jörg Frings-Fürst <debian@jff.email>  Wed, 03 Jul 2024 21:32:38 +0200
