=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND =  -Wl,--allow-multiple-definition

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
			-DXTRKCAD_USE_GETTEXT=ON \
			-DXTRKCAD_USE_GTK=ON \
			-DCMAKE_INSTALL_PREFIX:PATH=/usr/
