## xtrkcad 5.3.1GA

=== CMakeLists.txt ===
--- 
+++ 
@@ -48,8 +48,13 @@
 # Find document conversion tool
 find_package(Pandoc)
 
-# For handling and creation of bitmaps the FreeImage library is required
-find_package(FreeImage REQUIRED)
+# Flatpak
+find_package(Flatpak)
+
+# For handling and creation of bitmaps the FreeImage library is required on Windows
+if(WIN32)
+	find_package(FreeImage REQUIRED)
+endif()
 
 # check for GTK+ 2.0
 if(UNIX)
