=== distribution/CMakeLists.txt ===
--- 
+++ 
@@ -28,6 +28,9 @@
 
 IF(UNIX AND NOT APPLE)
 	ADD_SUBDIRECTORY(posix)
+    if(Flatpak_FOUND)
+	    ADD_SUBDIRECTORY(flatpak)
+    endif()
 ENDIF(UNIX AND NOT APPLE)
 
 IF(WIN32)
