=== app/bin/CMakeLists.txt ===
--- 
+++ 
@@ -168,6 +168,7 @@
     layout.h
     levenshtein.c
     linknoteui.c
+    locale.c
     lprintf.c
     macro.c
     manifest.c
@@ -213,6 +214,7 @@
 	trkseg.h
     trkseg.c
     tstraigh.c
+    toolbar.c
     turnout.c
     uthash.h
     utility.c
@@ -268,10 +270,14 @@
     target_link_libraries(xtrkcad-lib 
         PRIVATE 
         Libzip::Libzip 
-        FreeImage::FreeImage 
         Zlib::Zlib)
 endif()
 
+if(WIN32)
+    target_link_libraries(xtrkcad-lib 
+        PRIVATE 
+        FreeImage::FreeImage)
+endif()
 #
 # Start building the main program itself
 #
