=== app/lib/CMakeLists.txt ===
--- 
+++ 
@@ -68,7 +68,6 @@
 	install(FILES
 		xtrkcad${XTRKCAD_BETA}.desktop
 		DESTINATION "${XTRKCAD_SHARE_INSTALL_DIR}/applications"
-		RENAME xtrkcad.desktop
 		)
 	install(FILES
 		xtrkcad.xml
