=== app/tools/CMakeLists.txt ===
--- 
+++ 
@@ -7,4 +7,6 @@
 endif ()
 
 add_subdirectory(halibut)
+if ( WIN32 )
 add_subdirectory(pngtoxpm)
+endif()
