=== debian/changelog ===
xtrkcad (1:5.3.1GA-1) unstable; urgency=medium

  * debian/rules:
    - Add -std=gnu17 to CFLAGS to fix FTBFS with GCC-15 (Closes: #1098175).
  * debian/copyright:
    - Replace old FSF address.
    - Rewrite to make lrc happy.
  * debian/control:
    - Bump Standards-Version to 4.7.2.0.
    - Change Vcs-Git from git to https.
  * debian/patches/0005-fix_link_lib_failed.patch:
    - Fix Last-Update
  * overrides:
    - Remove now useless debian/source/lintian-overrides.
    - Remove source-is-missing from debian/xtrkcad-common.lintian-overrides.

 -- Jörg Frings-Fürst <debian@jff.email>  Sun, 26 Oct 2025 18:04:34 +0100
