=== debian/control ===
--- 
+++ 
@@ -14,9 +14,9 @@
  libzip-dev,
  pandoc
 Rules-Requires-Root: no
-Standards-Version: 4.7.0.0
+Standards-Version: 4.7.2.0
 Homepage: http://xtrkcad.org/
-Vcs-Git: git://git.jff.email/xtrkcad.git
+Vcs-Git: https://git.jff.email/cgit/xtrkcad.git
 Vcs-Browser: https://git.jff.email/cgit/xtrkcad.git
 
 Package: xtrkcad
