=== debian/rules ===
--- 
+++ 
@@ -6,6 +6,8 @@
 # hardening
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 export DEB_LDFLAGS_MAINT_APPEND =  -Wl,--allow-multiple-definition
+export CFLAGS = $(shell dpkg-buildflags --get CFLAGS) -std=gnu17
+
 
 %:
 	dh $@
